	cpu LMM
	.module sensor.c
	.area lit(rom, con, rel)
_FactoryDefault_Param_8::
	.byte 0,0
	.dbfile ./sensor.c
	.dbsym e FactoryDefault_Param_8 _FactoryDefault_Param_8 A[2:2]c
_FactoryDefault_Param_16::
	.word 500
	.word 500
	.word 50000
	.dbsym e FactoryDefault_Param_16 _FactoryDefault_Param_16 A[6:3]i
_FactoryDefault_Param_32::
	.word 0,0
	.dbsym e FactoryDefault_Param_32 _FactoryDefault_Param_32 A[4:1]l
_FactoryDefault_Param_168::
	.byte 'R,'G,'B,32,'C,'o,'l,'o,'r,32,'S,'e,'n,'s,'o,'r
	.byte 0
	.byte 0,0,0,0
	.byte 'F,'r,'a,'m,'e,32,'N,'u,'m,'b,'e,'r,0
	.byte 0,0,0,0,0,0,0,0
	.byte 'R,0
	.word 0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0
	.byte 'G,0
	.word 0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0
	.byte 'B,0
	.word 0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0
	.dbsym e FactoryDefault_Param_168 _FactoryDefault_Param_168 A[105:5:21]c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_NewSample::
	.byte 0
	.dbsym e NewSample _NewSample c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Start _Sensor_Start fV
_Sensor_Start::
	.dbline -1
	.dbline 128
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   sensor.c
; //  Version: 1.0, 2007/03/08
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  sensor specific functions 
; //
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; //#define __DEBUG__
; #include <m8c.h>        // part specific constants and macros
; #include "sensor.h"
; #include "psocgpioint.h"
; #include "psocapi.h"
; #include "feature.h"
; #include "parameters.h"
; #include "types_n_macros.h"
; //----------------------------------------
; // Sensor parameters
; // Factory Defaults are defined here (NUM_xxx are defined in "sensor.h")
; //----------------------------------------
; const BYTE FactoryDefault_Param_8   [NUM_PARAM_8] =
; {
; 	0x00,		// report mode
; 	0x00		// LED mode
; };
; 
; const WORD FactoryDefault_Param_16  [NUM_PARAM_16] = 
; {
; 	500,		// report rate [ms]
; 	500,		// sample rate [ms]
; 	50000		// sample rate [us]	(not used for this sensor)
; };
; 
; const DWORD FactoryDefault_Param_32  [NUM_PARAM_32] =
; {
; 	0x00000000	// currently no 32bit parameters
; };
; 
; const tParam_168 FactoryDefault_Param_168 [NUM_PARAM_168] =
; {
; 	"RGB Color Sensor",	// user device name
; 	"Frame Number",		// user name Channel 0
; 	"R",				// user name Channel 1
; 	"G",				// user name Channel 2
; 	"B"					// user name Channel 3
; };
; 
; 
; //----------------------------------------
; // this module's global variables
; //----------------------------------------
; tReport Report;
; 
; //----------------------------------------
; // function Prototypes
; //----------------------------------------
; static void Goto_I2C(void);
; static void Goto_SPI(void);
; 
; //----------------------------------------
; // constant definitions
; //----------------------------------------
; // ADJD-S313 device addresses
; #define ADDR_S313	0x58
; 
; // ADJD-S313 register addresses
; #define ADDR_ACQ	0x02
; 
; #define ADDR_SETUP0	0x03
; #define ADDR_SETUP1	0x04
; #define ADDR_SETUP2	0x0C
; #define ADDR_SETUP3	0x0D
; #define ADDR_SETUP4	0x0E
; 
; #define ADDR_PDASB	0x09
; #define ADDR_PDASG	0x0A
; #define ADDR_PDASR	0x0B
; 
; #define ADDR_TINTB	0x0F
; #define ADDR_TINTG	0x10
; #define ADDR_TINTR	0x11
; 
; #define ADDR_ADCB	0x42
; #define ADDR_ADCG	0x43
; #define ADDR_ADCR	0x44
; 
; //----------------------------------------
; // constant lookup-table for ADC->physical value conversion
; //----------------------------------------
; 
; //----------------------------------------
; // type definitions
; //----------------------------------------
; 
; typedef enum 
; {	
; 	eReset,
; 	eIdle,
; 	eReadADC
; } tFSM_Measure;
; 
; //----------------------------------------
; // variables
; 
; tFSM_Measure	FSM;
; WORD			Countdown_1ms;
; 
; static BYTE		PDASR, PDASG, PDASB;	// TODO: sensor optimization to define these six variables
; static BYTE		TINTR, TINTG, TINTB;
; 
; BOOL			NewSample = FALSE;
; 
; // store original drivemodes during suspend
; BYTE			DM0_2, DM0_1, DM0_0;
; BYTE			DM1_2, DM1_1, DM1_0;
; BYTE			DM2_2, DM2_1, DM2_0;
; 
; //-----------------------------------------------------------------------------
; // Initializes the Sensor 
; //-----------------------------------------------------------------------------
; void Sensor_Start ()
; {
	.dbline 129
; 	FSM = eReset;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline 132
; 
; 	// turn on power for the sensor
; 	GPIO_LOW(SLEEP)
	and REG[0x4],-5
	.dbline 134
; 	// deassert Reset
; 	GPIO_HIGH(XRST)
	or REG[0x4],8
	.dbline 137
; 
; 	// initialize the Cypress' I2C interface
; 	I2CHW_Start();
	push X
	xcall _I2CHW_Start
	.dbline 138
; 	I2CHW_EnableMstr();
	xcall _I2CHW_EnableMstr
	pop X
	.dbline -2
	.dbline 139
; }
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Suspend _Sensor_Suspend fV
_Sensor_Suspend::
	.dbline -1
	.dbline 144
; //-----------------------------------------------------------------------------
; // Prepare Sensor for Suspend
; //-----------------------------------------------------------------------------
; void Sensor_Suspend()
; {
	.dbline 146
; 	// turn off power for the sensor
; 	GPIO_HIGH(SLEEP)
	or REG[0x4],4
	.dbline 149
; 
; 	// disable I2C hardware
; 	I2CHW_DisableMstr();
	push X
	xcall _I2CHW_DisableMstr
	pop X
	.dbline 152
; 
; 	// store original drivemodes during  suspend
; 	DM0_2 = PRT0DM2;
	mov A,REG[0x3]
	mov REG[0xd0],>_DM0_2
	mov [_DM0_2],A
	.dbline 153
; 	DM0_1 = PRT0DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x1]
	mov REG[0xd0],>_DM0_1
	mov [_DM0_1],A
	and F,0xEF ; iopage = 0
	.dbline 154
; 	DM0_0 = PRT0DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[ 0]
	mov REG[0xd0],>_DM0_0
	mov [_DM0_0],A
	and F,0xEF ; iopage = 0
	.dbline 155
; 	DM1_2 = PRT1DM2;
	mov A,REG[0x7]
	mov REG[0xd0],>_DM1_2
	mov [_DM1_2],A
	.dbline 156
; 	DM1_1 = PRT1DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x5]
	mov REG[0xd0],>_DM1_1
	mov [_DM1_1],A
	and F,0xEF ; iopage = 0
	.dbline 157
; 	DM1_0 = PRT1DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[0x4]
	mov REG[0xd0],>_DM1_0
	mov [_DM1_0],A
	and F,0xEF ; iopage = 0
	.dbline 158
; 	DM2_2 = PRT2DM2;
	mov A,REG[0xb]
	mov REG[0xd0],>_DM2_2
	mov [_DM2_2],A
	.dbline 159
; 	DM2_1 = PRT2DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x9]
	mov REG[0xd0],>_DM2_1
	mov [_DM2_1],A
	and F,0xEF ; iopage = 0
	.dbline 160
; 	DM2_0 = PRT2DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[0x8]
	mov REG[0xd0],>_DM2_0
	mov [_DM2_0],A
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 175
; 	
; 	// set all I/Os to/from the sensor to High-Z Analog (=110), 
; 	// except the OFF_nON signal. 
; 	// OFF_nON is on Port0, all other signals on Port2
; /*	PRT0DM2 |= ~OFF_nON_MASK;
; 	PRT0DM1 |= ~OFF_nON_MASK;
; 	PRT0DM0 &=  OFF_nON_MASK;
; 	PRT1DM2  = 0xFF;
; 	PRT1DM1  = 0xFF;
; 	PRT1DM0  = 0x00;
; 	PRT2DM2  = 0xFF;
; 	PRT2DM1  = 0xFF;
; 	PRT2DM0  = 0x00;
; */
; }
L10:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Resume _Sensor_Resume fV
;              i -> X+1
;       ReadMode -> X+0
_Sensor_Resume::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 180
; //-----------------------------------------------------------------------------
; // Resume Sensor from Suspend mode
; //-----------------------------------------------------------------------------
; void Sensor_Resume()
; {
	.dbline 185
; 	BYTE ReadMode;
; 	BYTE i;
; 		
; 	// restore drivemodes for GPIOs to/from the sensor
; 	PRT2DM2 = DM2_2;
	mov REG[0xd0],>_DM2_2
	mov A,[_DM2_2]
	mov REG[0xb],A
	.dbline 186
; 	PRT2DM1 = DM2_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_1
	mov A,[_DM2_1]
	mov REG[0x9],A
	and F,0xEF ; iopage = 0
	.dbline 187
; 	PRT2DM0 = DM2_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_0
	mov A,[_DM2_0]
	mov REG[0x8],A
	and F,0xEF ; iopage = 0
	.dbline 188
; 	PRT1DM2 = DM1_2;
	mov REG[0xd0],>_DM1_2
	mov A,[_DM1_2]
	mov REG[0x7],A
	.dbline 189
; 	PRT1DM1 = DM1_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM1_1
	mov A,[_DM1_1]
	mov REG[0x5],A
	and F,0xEF ; iopage = 0
	.dbline 190
; 	PRT1DM0 = DM1_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM1_0
	mov A,[_DM1_0]
	mov REG[0x4],A
	and F,0xEF ; iopage = 0
	.dbline 191
; 	PRT0DM2 = DM0_2;
	mov REG[0xd0],>_DM0_2
	mov A,[_DM0_2]
	mov REG[0x3],A
	.dbline 192
; 	PRT0DM1 = DM0_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_1
	mov A,[_DM0_1]
	mov REG[0x1],A
	and F,0xEF ; iopage = 0
	.dbline 193
; 	PRT0DM0 = DM0_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_0
	mov A,[_DM0_0]
	mov REG[ 0],A
	and F,0xEF ; iopage = 0
	.dbline 196
; 
; 	// turn on power for the sensor
; 	GPIO_LOW(SLEEP)
	and REG[0x4],-5
	.dbline 198
; 	// Deassert reset
; 	GPIO_HIGH(XRST)
	or REG[0x4],8
	.dbline 199
; 	I2CHW_EnableMstr();
	push X
	xcall _I2CHW_EnableMstr
	pop X
	.dbline 201
; 
; 	FSM = eReset;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline -2
	.dbline 202
; }
L11:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 1 c
	.dbsym l ReadMode 0 c
	.dbend
	.dbfunc e I2C_ReadReg _I2C_ReadReg fc
;           Data -> X+1
;           fAck -> X+0
;        Address -> X-4
_I2C_ReadReg::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 209
; 
; 
; //-----------------------------------------------------------------------------
; // Read 8-bit register on I2C
; //-----------------------------------------------------------------------------
; BYTE I2C_ReadReg(BYTE Address) 
; {
	.dbline 213
; 	BYTE fAck;
; 	BYTE Data;
; 
; 	fAck = I2CHW_fSendStart      (ADDR_S313, I2CHW_WRITE);
	push X
	mov X,0
	mov A,88
	xcall _I2CHW_fSendStart
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 214
; 	fAck = I2CHW_fWrite          (Address);
	push X
	mov A,[X-4]
	xcall _I2CHW_fWrite
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 215
; 	fAck = I2CHW_fSendRepeatStart(ADDR_S313, I2CHW_READ);
	push X
	mov X,1
	mov A,88
	xcall _I2CHW_fSendRepeatStart
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 216
; 	Data = I2CHW_bRead           (I2CHW_NAKslave);
	push X
	mov A,0
	xcall _I2CHW_bRead
	mov REG[0xd0],>__r0
	pop X
	mov [X+1],A
	.dbline 217
; 	       I2CHW_SendStop();	
	push X
	xcall _I2CHW_SendStop
	pop X
	.dbline 219
; 	
; 	return Data;
	mov A,[X+1]
	mov REG[0xd0],>__r0
	.dbline -2
L12:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Data 1 c
	.dbsym l fAck 0 c
	.dbsym l Address -4 c
	.dbend
	.dbfunc e I2C_WriteReg _I2C_WriteReg fV
;           fAck -> X+0
;           Data -> X-5
;        Address -> X-4
_I2C_WriteReg::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 227
; }
; 
; 
; //-----------------------------------------------------------------------------
; // Write 8-bit register on I2C
; //-----------------------------------------------------------------------------
; void I2C_WriteReg(BYTE Address, BYTE Data) 
; {
	.dbline 230
; 	BYTE fAck;
; 
; 	fAck = I2CHW_fSendStart      (ADDR_S313, I2CHW_WRITE);
	push X
	mov X,0
	mov A,88
	xcall _I2CHW_fSendStart
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 231
; 	fAck = I2CHW_fWrite          (Address);
	push X
	mov A,[X-4]
	xcall _I2CHW_fWrite
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 232
; 	fAck = I2CHW_fWrite          (Data);
	push X
	mov A,[X-5]
	xcall _I2CHW_fWrite
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 233
; 	       I2CHW_SendStop();	
	push X
	xcall _I2CHW_SendStop
	pop X
	.dbline -2
	.dbline 234
; }
L13:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l fAck 0 c
	.dbsym l Data -5 c
	.dbsym l Address -4 c
	.dbend
	.area lit(rom, con, rel)
L15:
	.byte 2,3
	.byte 4,12
	.byte 13,14
	.byte 9,10
	.byte 11,15
	.byte 16,17
	.byte 'B,'C
	.byte 'D
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Specific_Feature _Sensor_Specific_Feature fc
	.dbsym s ValidAddr L15 A[15:15]c
;              i -> X+0
_Sensor_Specific_Feature::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 248
; 
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // cannot be handled with the standard functionality in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //
; //	return Value: number of Parameter bytes (1-31) that are 
; //				  returned in the IN report
; //-----------------------------------------------------------------------------
; BYTE Sensor_Specific_Feature(void)
; {
	.dbline 257
; 	#define NofReg 15
; 	static const BYTE ValidAddr[] = {0x02, 
; 							  0x03, 0x04, 0x0C, 0x0D, 0x0E, 
; 							  0x09, 0x0A, 0x0B, 
; 							  0x0F, 0x10, 0x11, 
; 							  0x42, 0x43, 0x44};	
; 	BYTE i;
; 	
; 	if ( (FEATURE_RPT.OUT.Target == eSensor) && (FEATURE_RPT.OUT.ParamSize == 1) )
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+1],3
	jnz L16
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA+2],1
	jnz L16
	.dbline 258
; 	{
	.dbline 259
; 		for (i=0; i<NofReg; i++)
	mov [X+0],0
	xjmp L23
L20:
	.dbline 261
; 			// check if requested address is a valid S313 register
; 			if (FEATURE_RPT.OUT.Index_LSB == ValidAddr[i])
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<L15
	adc [__r0],>L15
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	mov REG[0xd0],>__r0
	cmp A,[__r0]
	jnz L24
	.dbline 262
; 			{
	.dbline 263
; 				if (FEATURE_RPT.OUT.Get_nSet)
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	cmp [_USB_INTERFACE_0_FEATURE_RPT_DATA],0
	jz L27
	.dbline 264
; 				{ // GET
	.dbline 265
; 					FEATURE_RPT.IN.Param[0] = I2C_ReadReg(FEATURE_RPT.OUT.Index_LSB);
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _I2C_ReadReg
	add SP,-1
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov [_USB_INTERFACE_0_FEATURE_RPT_DATA+1],A
	.dbline 266
; 					return 1;
	mov REG[0xd0],>__r0
	mov A,1
	xjmp L14
L27:
	.dbline 269
; 				}
; 				else
; 				{ // SET
	.dbline 270
; 				 	I2C_WriteReg(FEATURE_RPT.OUT.Index_LSB, FEATURE_RPT.OUT.Param[0]);
	mov REG[0xd0],>_USB_INTERFACE_0_FEATURE_RPT_DATA
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+5]
	push A
	mov A,[_USB_INTERFACE_0_FEATURE_RPT_DATA+3]
	push A
	xcall _I2C_WriteReg
	add SP,-2
	.dbline 271
; 				 	return 0;
	mov REG[0xd0],>__r0
	mov A,0
	xjmp L14
L24:
L21:
	.dbline 259
	inc [X+0]
L23:
	.dbline 259
	cmp [X+0],15
	jc L20
X0:
	.dbline 274
; 				}
; 			}
; 	}
L16:
	.dbline 275
; 	return 0;
	mov REG[0xd0],>__r0
	mov A,0
	.dbline -2
L14:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 0 c
	.dbend
	.dbfunc e Sensor_Specific_Parameter _Sensor_Specific_Parameter fV
; NumberOfReturnedBytes -> X-5
_Sensor_Specific_Parameter::
	.dbline -1
	push X
	mov X,SP
	.dbline 286
; }
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // sets / gets a 8/16/32/168bit parameter in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //-----------------------------------------------------------------------------
; void Sensor_Specific_Parameter(BYTE *NumberOfReturnedBytes)
; {
	.dbline 287
; 	*NumberOfReturnedBytes = 0;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline -2
	.dbline 288
; }
L33:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l NumberOfReturnedBytes -5 pc
	.dbend
	.area lit(rom, con, rel)
L35:
	.byte 3,4
	.byte 12,13
	.byte 14
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Reset _Sensor_Reset fV
	.dbsym s SetupAddr L35 A[5:5]c
;              i -> X+0
_Sensor_Reset::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 294
; 
; //-----------------------------------------------------------------------------
; // Perform a reset of the ADJD-S313 sensor
; //-----------------------------------------------------------------------------
; void Sensor_Reset()
; {
	.dbline 300
; 	static const BYTE SetupAddr[5] = {ADDR_SETUP0, ADDR_SETUP1, ADDR_SETUP2, ADDR_SETUP3, ADDR_SETUP4};
; 	BYTE i;
; 	
; 	
; 	// -- Reset pulse (active low)
; 	GPIO_LOW(XRST)
	and REG[0x4],-9
	.dbline 301
	mov [X+0],0
	xjmp L39
L36:
	.dbline 301
L37:
	.dbline 301
	inc [X+0]
L39:
	.dbline 301
; 	for (i=0; i<10; i++);	// delay at least 10us
	cmp [X+0],10
	jc L36
X1:
	.dbline 302
; 	GPIO_HIGH(XRST)
	or REG[0x4],8
	.dbline 303
	mov [X+0],0
	xjmp L43
L40:
	.dbline 303
L41:
	.dbline 303
	inc [X+0]
L43:
	.dbline 303
; 	for (i=0; i<10; i++);	// delay at least 10us
	cmp [X+0],10
	jc L40
X2:
	.dbline 306
; 	
; 	// -- SETUP registers
; 	for (i=0; i<5; i++)
	mov [X+0],0
	xjmp L47
L44:
	.dbline 307
	mov A,1
	push A
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<L35
	adc [__r0],>L35
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	push A
	xcall _I2C_WriteReg
	add SP,-2
L45:
	.dbline 306
	inc [X+0]
L47:
	.dbline 306
	cmp [X+0],5
	jc L44
X3:
	.dbline -2
	.dbline 308
; 		I2C_WriteReg(SetupAddr[i], 0x01);
; }
L34:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 0 c
	.dbend
	.dbfunc e Sensor_SetGain _Sensor_SetGain fV
;          TINTB -> X-9
;          TINTG -> X-8
;          TINTR -> X-7
;          PDASB -> X-6
;          PDASG -> X-5
;          PDASR -> X-4
_Sensor_SetGain::
	.dbline -1
	push X
	mov X,SP
	.dbline 314
; 
; //-----------------------------------------------------------------------------
; // Set Photodiode size and integration time
; //-----------------------------------------------------------------------------
; void Sensor_SetGain(BYTE PDASR, BYTE PDASG, BYTE PDASB,  BYTE TINTR, BYTE TINTG, BYTE TINTB)
; {
	.dbline 316
; 	// -- PDAS registers
; 	I2C_WriteReg(ADDR_PDASR, PDASR);
	mov A,[X-4]
	push A
	mov A,11
	push A
	xcall _I2C_WriteReg
	.dbline 317
; 	I2C_WriteReg(ADDR_PDASG, PDASG);
	mov A,[X-5]
	push A
	mov A,10
	push A
	xcall _I2C_WriteReg
	add SP,-4
	.dbline 318
; 	I2C_WriteReg(ADDR_PDASB, PDASB);
	mov A,[X-6]
	push A
	mov A,9
	push A
	xcall _I2C_WriteReg
	.dbline 321
; 
; 	// -- TINT registers
; 	I2C_WriteReg(ADDR_TINTR, TINTR);
	mov A,[X-7]
	push A
	mov A,17
	push A
	xcall _I2C_WriteReg
	add SP,-4
	.dbline 322
; 	I2C_WriteReg(ADDR_TINTR, TINTG);
	mov A,[X-8]
	push A
	mov A,17
	push A
	xcall _I2C_WriteReg
	.dbline 323
; 	I2C_WriteReg(ADDR_TINTR, TINTB);
	mov A,[X-9]
	push A
	mov A,17
	push A
	xcall _I2C_WriteReg
	add SP,-4
	.dbline -2
	.dbline 324
; }
L48:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l TINTB -9 c
	.dbsym l TINTG -8 c
	.dbsym l TINTR -7 c
	.dbsym l PDASB -6 c
	.dbsym l PDASG -5 c
	.dbsym l PDASR -4 c
	.dbend
	.dbfunc e Sensor_ReadRGB _Sensor_ReadRGB fV
;              B -> X-9
;              G -> X-7
;              R -> X-5
_Sensor_ReadRGB::
	.dbline -1
	push X
	mov X,SP
	.dbline 330
; 
; //-----------------------------------------------------------------------------
; // Read R, G, B ADC registers
; //-----------------------------------------------------------------------------
; void Sensor_ReadRGB(BYTE *R, BYTE *G, BYTE *B)
; {
	.dbline 332
; 	// -- Start A2D conversion, wait for the end of this
; 	I2C_WriteReg(ADDR_ACQ, 0x02);
	mov A,2
	push A
	push A
	xcall _I2C_WriteReg
	add SP,-2
L50:
	.dbline 333
L51:
	.dbline 333
; 	while (I2C_ReadReg(ADDR_ACQ) != 0x00);
	mov A,2
	push A
	xcall _I2C_ReadReg
	add SP,-1
	mov REG[0xd0],>__r0
	cmp A,0
	jnz L50
	.dbline 336
; 	
; 	// -- Read ADC values
; 	*R = I2C_ReadReg(ADDR_ADCR);
	mov A,68
	push A
	xcall _I2C_ReadReg
	add SP,-1
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X-4]
	mov [__r3],A
	mov A,[X-5]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 337
; 	*G = I2C_ReadReg(ADDR_ADCG);
	mov A,67
	push A
	xcall _I2C_ReadReg
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X-6]
	mov [__r3],A
	mov A,[X-7]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 338
; 	*B = I2C_ReadReg(ADDR_ADCB);
	mov A,66
	push A
	xcall _I2C_ReadReg
	add SP,-2
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X-8]
	mov [__r3],A
	mov A,[X-9]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline -2
	.dbline 339
; }
L49:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l B -9 pc
	.dbsym l G -7 pc
	.dbsym l R -5 pc
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
L54:
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./sensor.c
L55:
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./sensor.c
L56:
	.byte 0
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_FSM_Measure _Sensor_FSM_Measure fV
	.dbsym s B L56 c
	.dbsym s G L55 c
	.dbsym s R L54 c
;              i -> X+0
_Sensor_FSM_Measure::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 351
; 
; //-----------------------------------------------------------------------------
; // void Sensor_FSM_Measure(void)
; //
; //	finite state machine to control the measurement process for 
; //  the Sensor
; //
; //  IMPORTANT: 	call this routine once every millisecond. Otherwise the timing
; //				parameters cannot be met.
; //-----------------------------------------------------------------------------
; void Sensor_FSM_Measure() 
; {
	.dbline 356
; 	static BYTE R,G,B;
; 	BYTE i;
; 
; 	// decrement millisecond counter
; 	if (Countdown_1ms != 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz X5
	cmp [_Countdown_1ms+1],0
	jz L57
X5:
	.dbline 357
; 		Countdown_1ms--;
	mov REG[0xd0],>_Countdown_1ms
	dec [_Countdown_1ms+1]
	sbb [_Countdown_1ms],0
L57:
	.dbline 360
; 
; 	// process actual state machine
; 	switch (FSM)
	mov REG[0xd0],>_FSM
	mov A,[_FSM]
	mov [X+2],A
	mov [X+1],0
	cmp [X+1],0
	jnz X6
	cmp [X+2],0
	jz L62
X6:
	cmp [X+1],0
	jnz X7
	cmp [X+2],1
	jz L63
X7:
	cmp [X+1],0
	jnz X8
	cmp [X+2],2
	jz L66
X8:
	xjmp L59
X4:
	.dbline 361
; 	{
L62:
	.dbline 364
; 		case eReset:
; 			// activate Reset (active low)
; 			GPIO_LOW(XRST)
	and REG[0x4],-9
	.dbline 365
; 			FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],1
	.dbline 366
; 			Sensor_Reset();
	xcall _Sensor_Reset
	.dbline 368
; //			Sensor_SetGain(PDASR, PDASG, PDASB,  TINTR, TINTG, TINTB);
; 			break;
	xjmp L60
L63:
	.dbline 372
; 			
; 		case eIdle: 
; 			// deassert Reset
; 			GPIO_HIGH(XRST)
	or REG[0x4],8
	.dbline 373
; 			if (Countdown_1ms == 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz L60
	cmp [_Countdown_1ms+1],0
	jnz L60
X9:
	.dbline 374
; 			{
	.dbline 375
; 				Get_Param_16(PAR16_SAMPLERATE_MS, VOLATILE, &Countdown_1ms);;
	mov A,>_Countdown_1ms
	push A
	mov A,<_Countdown_1ms
	push A
	mov A,0
	push A
	mov A,1
	push A
	xcall _Get_Param_16
	add SP,-4
	.dbline 375
	.dbline 376
; 				FSM = eReadADC;					  
	mov REG[0xd0],>_FSM
	mov [_FSM],2
	.dbline 377
; 			}
	.dbline 378
; 			break;			
	xjmp L60
L66:
	.dbline 381
; 			
; 		case eReadADC:
; 			Sensor_ReadRGB(&R, &G, &B);
	mov A,>L56
	push A
	mov A,<L56
	push A
	mov A,>L55
	push A
	mov A,<L55
	push A
	mov A,>L54
	push A
	mov A,<L54
	push A
	xcall _Sensor_ReadRGB
	add SP,-6
	.dbline 383
; 
; 			Report.Ch1_LSB = R;
	mov REG[0xd0],>L54
	mov A,[L54]
	mov REG[0xd0],>_Report
	mov [_Report+2],A
	.dbline 384
; 			Report.Ch1_MSB = 0x00;
	mov [_Report+3],0
	.dbline 386
; 
; 			Report.Ch2_LSB = G;
	mov REG[0xd0],>L55
	mov A,[L55]
	mov REG[0xd0],>_Report
	mov [_Report+4],A
	.dbline 387
; 			Report.Ch2_MSB = 0x00;
	mov [_Report+5],0
	.dbline 389
; 
; 			Report.Ch3_LSB = B;
	mov REG[0xd0],>L56
	mov A,[L56]
	mov REG[0xd0],>_Report
	mov [_Report+6],A
	.dbline 390
; 			Report.Ch3_MSB = 0x00;
	mov [_Report+7],0
	.dbline 392
; 
; 			NewSample = TRUE;
	mov REG[0xd0],>_NewSample
	mov [_NewSample],1
	.dbline 394
; 
; 			FSM = eIdle;
	mov REG[0xd0],>_FSM
	mov [_FSM],1
	.dbline 395
; 			break;			
L59:
L60:
	.dbline -2
	.dbline 397
; 	}
; }
L53:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 0 c
	.dbend
	.dbfunc e Sensor_Debug _Sensor_Debug fV
_Sensor_Debug::
	.dbline -1
	.dbline 401
; 
; //-----------------------------------------------------------------------------
; void Sensor_Debug(void)
; {
	.dbline -2
	.dbline 403
; 	/* currently no debug function */
; }
L73:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_0::
	.byte 0
	.dbsym e DM2_0 _DM2_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_1::
	.byte 0
	.dbsym e DM2_1 _DM2_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_2::
	.byte 0
	.dbsym e DM2_2 _DM2_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM1_0::
	.byte 0
	.dbsym e DM1_0 _DM1_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM1_1::
	.byte 0
	.dbsym e DM1_1 _DM1_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM1_2::
	.byte 0
	.dbsym e DM1_2 _DM1_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_0::
	.byte 0
	.dbsym e DM0_0 _DM0_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_1::
	.byte 0
	.dbsym e DM0_1 _DM0_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_2::
	.byte 0
	.dbsym e DM0_2 _DM0_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_TINTB:
	.byte 0
	.dbsym s TINTB _TINTB c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_TINTG:
	.byte 0
	.dbsym s TINTG _TINTG c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_TINTR:
	.byte 0
	.dbsym s TINTR _TINTR c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_PDASB:
	.byte 0
	.dbsym s PDASB _PDASB c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_PDASG:
	.byte 0
	.dbsym s PDASG _PDASG c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_PDASR:
	.byte 0
	.dbsym s PDASR _PDASR c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Countdown_1ms::
	.byte 0,0
	.dbsym e Countdown_1ms _Countdown_1ms i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_FSM::
	.byte 0
	.dbsym e FSM _FSM c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Report::
	.byte 0,0,0,0,0,0,0,0
	.dbsym e Report _Report X
